#!/usr/bin/env ruby

# https://github.com/icalendar/icalendar
require 'icalendar'
require 'date'

source='/Volumes/All/Local/Web/math.columbia.edu/OfficeHours/source'
officehours = "#{source}/officehours.txt"
calendar = "#{source}/BusyCal/OfficeHrs.ics"

cal = Icalendar::Calendar.parse(File.open(calendar)).first

now = DateTime.now
now -= now.wday

events = []
cal.events.each do |event|
  # 4/10 b 4:30-6:00
  start = event.dtstart
  stop  = event.dtend
  next if start.to_datetime < now
  events << [start, stop]
end

schedule = ''
events.sort.each do |start, stop|
  if start.class == Icalendar::Values::Date
    stop -= 1
    start_text = start.strftime('%-m/%-d')
    if start.day == stop.day
      schedule << "#{start_text} g\n"
    else
      format = start.month != stop.month ? '%-m/%-d' : '%-d'
      stop_text = stop.strftime(format)
      schedule << "#{start_text}-#{stop_text} g\n"
    end
  elsif start.class == Icalendar::Values::DateTime
    start = start.strftime('%-m/%-d b %-I:%M')
    stop  = stop.strftime('%-I:%M')
    schedule << "#{start}-#{stop}\n"
  else
    print "unrecognized class"
  end
end

File.open(officehours, 'w') do |f|
  f.puts(schedule)
end
