#!/bin/bash

# cd to parent directory of this script
bin=$( dirname "$0" )
cd "$bin/.."

# insert tag text
insert () {
  perl -p -e "s|<-$1->|$2|"
}

# output title
output () {
  markdown | cat head - foot | insert title "$1"
}

# index.php
cat index.md |\
   insert officehours "$( bin/calendar.py officehours.txt )" |\
   output "$(cat title)" > ../index.php

# source.php
cat source.md |\
   output "$(cat title) (Page Sources)" > ../source.php

# create tarball, update math.columbia.edu, and open page
cd ..
math-tarball.sh
math-update.rb
math-open.sh
